REST API :: Return Values

Following is a complete list of fields returned face.com's API responses:

Tag Response Fields

Methods: faces.detect, faces.recognize, faces.group, tags.get, facebook.get

FieldTypeDescription
photosarrayList of all the photo objects that were included in the request, one photo per URL specified
urlstringPhoto url as specified in the request
pidstringPhoto id on the face.com platform, can be used as reference instead of URL for follow-up calls to methods that support it
widthintegerPhoto width in pixels
heightintegerPhoto height in pixels
tagsarrayList of zero or more face tag objects found in the photo
groupsarrayList of one or more groups of faces found in photos, when using faces.group. Each object in this array contains:
gid: The group's ID
uid: A matching UID for the group. Only works if the call provides a list of UIDs, and a UID is matched with this group
tids: A list of one or more Tag Ids (see tid below).Note: If the gid=null and the uid=null, this means this is the ungrouped group. Those are all the faces that had no matching face, or faces that cannot be group at the moment (such as profile posed faces).
tidstringTag id on the face.com platform. Tag IDs are temporary until used in tags.save calls to associate the tag with a specific user ID, at which point they become persistent.
recognizablebooleanNot all tags can be used for recognition or training (For example, profile posed faces). This fields is True for tags that can be recognized or can be used for training set. False otherwise. For tags that were saved before this field was added to the API, value is null, which means it can be either recognizable or not.
thresholdinteger(faces.recognize only) The recommended confidence threshold from 0-100 to use when deciding which recognition results to display. The threshold changes based on the quality of faces found, as well as the size of the uids list specified when calling faces.recognize.
uidsarray(faces.recognize only) List of possible matches for the face tag. Each entry in this list has 2 fields: uid: a user id match for the face tag. Only uids that were specified during the faces.recognize call (either explicitly or through a list) will be returned. 

confidence: score from 0-100 (%). Refer to the threshold field for a recommendation of which confidence scores are high/low for this call. When tags are saved, the confidence score is always 100.

labelstringOptional text label describing the tag. must have been previously specified through a tags.add or tags.save call.
confirmedbooleanSpecifies whether a tag has been confirmed or is in a temporary state. Tags are confirmed through calls to tags.save, tags.add, and with facebook tags - via facebook's user interface. Unconfirmed tags are also referred to as temporary, which means that they are not persisted anywhere.All confirmed tags have the confidence score of 100.
manualbooleanFalse by default, on true if the tag was added through the tags.add call which supports manual addition of otherwise undetected faces.
(tag) widthfloatFace tag width as 0-100% of photo width
(tag) heightfloatFace tag height as 0-100% of photo height
centerarrayx & y coordinates of tag face's center point, as 0-100% of photo width and height
eye_leftarrayx & y coordinates of left eye, as 0-100% of photo width and height
eye_rightarrayx & y coordinates of right eye, as 0-100% of photo width and height
mouth_leftarrayx & y coordinates of left edge of mouth, as 0-100% of photo width and height
mouth_centerarrayx & y coordinates of center of mouth, as 0-100% of photo width and height
mouth_rightarrayx & y coordinates of right edge of mouth, as 0-100% of photo width and height
nosearrayx & y coordinates of nose tip, as 0-100% of photo width and height
yawfloatyaw (facing sideways) angle value as -90 to 90
pitchfloatpitch (up or down) angle value as -90 to 90
rollfloatroll (face rotation) angle value as -90 to 90
attributesarraylist of detected facial attributes (currently gender, glasses, and smiling) - Each attribute object consist of two fields: confidence and value. Value is a string. Confidence - int (precent)
genderobjectmale/female value and confidence
glassesobjecttrue/false value and confidence, true when glasses are detected
smilingobjecttrue/false value and confidence, true when a person is smiling in a photo
moodobjecthappy/sad/angry/surprised/neutral value and confidence, based on the expression of the person in the the photo.
lipsobjectsealed/parted/kissing value and confidence, describing the state of the person's lips
faceobjectvalue is always set to true. confidence of this tag being a face. Confidence lower than 50% have high probability being false-positives

Response Status

methods: all

FieldTypeDescription
statusstring'success',  'failure', or 'partial'. Partial is used when a request has multiple photos in the response, and has one or more failures  mixed with successful responses (e.g. wrong URLs in for some of the photos specified).
error_codeintegererror code, specified only when an error occurs
error_messagestringerror message, specified only when an error occurs

Usage Response

methods: all rate limited methods, account.limits

FieldTypeDescription
usedintegeramount of photos that were processed since last rate-limit reset time (1 hour)
remainingintegeramount of photos remaining in current time window
limitintegerthe total photos limit permitted in the current 1-hour window
reset_timeintegerGMT unix-timestamp of next limit reset time
reset_time_textstringGMT unix-timestamp of next limit reset time (in text)

Error Codes

methods: all

error_codeerror_message
20IMG_DECODE_ERROR
21IMG_RESIZE_ERROR
30DOWNLOAD_ERROR
31DOWNLOAD_ERROR_FILE_NOT_FOUND
32DOWNLOAD_ERROR_SERVER_TIMEOUT
33DOWNLOAD_ERROR_FILE_TOO_LARGE
34DOWNLOAD_ERROR_MALFORMED_URL
35DOWNLOAD_ERROR_UNKNOWN_HOST
36DOWNLOAD_ERROR_CONNECTION_REFUSED
104INTERNAL_ERROR
105SERVICE_TEMPORARILY_UNAVAILABLE
107UNKNOWN_ERROR
201API_KEY_DOES_NOT_EXIST
202API_KEY_USAGE_PASSED_QUOTA
203API_KEY_CONCURRENT_USAGE_PASSED_QUOTA
204API_KEY_NOT_AUTHENTICATED
205API_PASSWORD_NOT_CORRECT
206MAX_NUMBERS_OF_UIDS_TRAINED_IN_NAMESPACE_EXCEEDED
207TOO_MANY_ERRORS
301TAG_NOT_FOUND
302FACEBOOK_EXCEPTION
303FILTER_SYNTAX_ERROR
304AUTHORIZATION_ERROR
305TWITTER_EXCEPTION
306TAG_ALREADY_EXIST
307ACTION_NOT_PERMITTED
401UNKNWOWN_REST_METHOD
402MISSING_ARGUMENTS
403MISSING_USER_NAMESPACE
404UNAUTHORIZED_USER_NAMESPACE
405UNAUTHORIZED_UID
406INVALID_ARGUMENTS_VALUE
407ARGUMENT_LIST_TOO_LONG
408UNAUTHORIZED_CALLBACK_URL_DOMAIN
409UID_TOO_LONG
410SYNCHRONOUS_REQUEST_TOO_BIG